diff --git a/sources/pyside6/libpyside/qobjectconnect.cpp b/sources/pyside6/libpyside/qobjectconnect.cpp
index 72c80645f..691ff0c30 100644
--- a/sources/pyside6/libpyside/qobjectconnect.cpp
+++ b/sources/pyside6/libpyside/qobjectconnect.cpp
@@ -10,11 +10,27 @@
 #include "shiboken.h"
 #include "basewrapper.h"
 #include "autodecref.h"
+#include <helper.h>
+#include <iostream>
 
 #include <QtCore/QDebug>
 #include <QtCore/QMetaMethod>
 #include <QtCore/QObject>
 
+std::ostream &operator<<(std::ostream &str, const QObject *o)
+{
+    if (o != nullptr) {
+        str << o->metaObject()->className() << '(' << static_cast<const void*>(o);
+        auto on = o->objectName();
+        if (!on.isEmpty())
+            str << ", \"" << on.toLocal8Bit().constData() << '"';
+        str << ')';
+    } else {
+        str << "QObject(0)";
+    }
+    return str;
+}
+
 static bool isMethodDecorator(PyObject *method, bool is_pymethod, PyObject *self)
 {
     Shiboken::AutoDecRef methodName(PyObject_GetAttr(method, Shiboken::PyMagicName::name()));
@@ -73,6 +89,8 @@ static GetReceiverResult getReceiver(QObject *source, const char *signal,
                                      PyObject *callback)
 {
     GetReceiverResult result;
+    std::cerr << __FUNCTION__ << " >" << source << " cb=" << signal
+              << "\" cb=" << Shiboken::debugPyObject(callback) << '\n';
 
     bool forceGlobalReceiver = false;
     if (PyMethod_Check(callback)) {
@@ -110,9 +128,14 @@ static GetReceiverResult getReceiver(QObject *source, const char *signal,
             PySide::Signal::getCallbackSignature(signal, result.receiver, callback,
                                                  result.usingGlobalReceiver).toLatin1();
         const QMetaObject *metaObject = result.receiver->metaObject();
+        qDebug() <<  __FUNCTION__ << " bug 1019: sig=" << result.callbackSig
+                << "slotIndex=" << result.slotIndex
+                << "PyMethod_Check=" << PyMethod_Check(callback)
+                 << metaObject->className() << "methodOffset=" << metaObject->methodOffset();
         result.slotIndex = metaObject->indexOfSlot(result.callbackSig.constData());
         if (result.slotIndex != -1 && result.slotIndex < metaObject->methodOffset()
             && PyMethod_Check(callback)) {
+            qDebug() <<  __FUNCTION__ << " bug 1019: trigger/usingGlobalReceiver";
             result.usingGlobalReceiver = true;
         }
     }
@@ -133,6 +156,8 @@ static GetReceiverResult getReceiver(QObject *source, const char *signal,
         result.slotIndex = metaObject->indexOfSlot(result.callbackSig.constData());
     }
 
+    qDebug().noquote().nospace() << __FUNCTION__ << " >" << source
+                                 << '"' << signal << "\"rets=" << result;
     return result;
 }
 
@@ -172,6 +197,8 @@ QMetaObject::Connection qobjectConnect(QObject *source, QMetaMethod signal,
 QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *signal,
                                                PyObject *callback, Qt::ConnectionType type)
 {
+    std::cerr << __FUNCTION__ << " >" << source << " cb=" << signal
+              << " \"cb=" << Shiboken::debugPyObject(callback) << ' ' << type << '\n';
     if (!signal || !PySide::Signal::checkQtSignal(signal))
         return {};
 
@@ -226,24 +253,32 @@ QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *sign
 
     const QMetaMethod signalMethod = receiver.receiver->metaObject()->method(signalIndex);
     static_cast<FriendlyQObject *>(source)->connectNotify(signalMethod);
+    qDebug() << __FUNCTION__ << '<' << source << signal << connection << '\n';
     return connection;
 }
 
 bool qobjectDisconnectCallback(QObject *source, const char *signal, PyObject *callback)
 {
+    std::cerr << __FUNCTION__ << " >" << source << " cb=" << signal
+              << " cb=" << Shiboken::debugPyObject(callback) << '\n';
     if (!PySide::Signal::checkQtSignal(signal))
         return false;
 
     // Extract receiver from callback
     const GetReceiverResult receiver = getReceiver(nullptr, signal, callback);
-    if (receiver.receiver == nullptr && receiver.self == nullptr)
+    if (receiver.receiver == nullptr && receiver.self == nullptr) {
+        qDebug() << __FUNCTION__ << "getReceiver fail!";
         return false;
+    }
 
     const int signalIndex = source->metaObject()->indexOfSignal(signal + 1);
     const int slotIndex = receiver.slotIndex;
+    qDebug() << __FUNCTION__ << "signalIndex=" << signalIndex << "slotIndex=" << slotIndex;
 
-    if (!QMetaObject::disconnectOne(source, signalIndex, receiver.receiver, slotIndex))
+    if (!QMetaObject::disconnectOne(source, signalIndex, receiver.receiver, slotIndex)) {
+        qDebug() << __FUNCTION__ << "QMetaObject::disconnectOne=fail\n";
         return false;
+    }
 
     Q_ASSERT(receiver.receiver);
     const QMetaMethod slotMethod = receiver.receiver->metaObject()->method(slotIndex);
@@ -253,6 +288,7 @@ bool qobjectDisconnectCallback(QObject *source, const char *signal, PyObject *ca
         PySide::SignalManager &signalManager = PySide::SignalManager::instance();
         signalManager.releaseGlobalReceiver(source, receiver.receiver);
     }
+    qDebug() << __FUNCTION__ << "ok\n";
     return true;
 }
 
diff --git a/sources/pyside6/libpyside/signalmanager.cpp b/sources/pyside6/libpyside/signalmanager.cpp
index c2799697c..f8f916c4a 100644
--- a/sources/pyside6/libpyside/signalmanager.cpp
+++ b/sources/pyside6/libpyside/signalmanager.cpp
@@ -668,7 +668,7 @@ int SignalManager::registerMetaMethodGetIndex(QObject *source, const char *signa
         }
 
         if (type == QMetaMethod::Slot) {
-            qCWarning(lcPySide).noquote().nospace()
+            qWarning().noquote().nospace()
                 << "Warning: Registering dynamic slot \""
                 << signature << "\" on " << source->metaObject()->className()
                 << ". Consider annotating with " << slotSignature(signature);