diff --git a/src/designer/src/components/propertyeditor/propertyeditor.cpp b/src/designer/src/components/propertyeditor/propertyeditor.cpp
index b06827f21..2d73947ce 100644
--- a/src/designer/src/components/propertyeditor/propertyeditor.cpp
+++ b/src/designer/src/components/propertyeditor/propertyeditor.cpp
@@ -1041,7 +1041,10 @@ void PropertyEditor::setObject(QObject *object)
                     if (dynamicProperty)
                         m_dynamicGroup = groupProperty;
                     if (m_currentBrowser == m_treeBrowser && item) {
-                        m_treeBrowser->setBackgroundColor(item, propertyColor(groupProperty));
+                        auto c =  propertyColor(groupProperty);
+                        qDebug() << __FUNCTION__ << groupProperty->propertyName() << c
+                                 << c.name();
+                        m_treeBrowser->setBackgroundColor(item, c);
                         groupProperty->setModified(true);
                     }
                 }
diff --git a/src/designer/src/designer/main.cpp b/src/designer/src/designer/main.cpp
index 445996202..7047f8145 100644
--- a/src/designer/src/designer/main.cpp
+++ b/src/designer/src/designer/main.cpp
@@ -5,6 +5,8 @@
 #include <QtCore/qlibraryinfo.h>
 #include <QtCore/qdir.h>
 #include <QtCore/qoperatingsystemversion.h>
+#include <qstyle.h>
+#include <qdebug.h>
 
 #include <stdlib.h>
 
@@ -24,6 +26,8 @@ int main(int argc, char *argv[])
     QCoreApplication::setAttribute(Qt::AA_ShareOpenGLContexts);
 
     QDesigner app(argc, argv);
+    qDebug() << qVersion() <<  app.style()->objectName();
+
     switch (app.parseCommandLineArguments()) {
     case QDesigner::ParseArgumentsSuccess:
         break;
diff --git a/src/designer/src/designer/qdesigner.cpp b/src/designer/src/designer/qdesigner.cpp
index 5f7418cdf..6730c76b3 100644
--- a/src/designer/src/designer/qdesigner.cpp
+++ b/src/designer/src/designer/qdesigner.cpp
@@ -234,8 +234,6 @@ QDesigner::ParseArgumentsResult QDesigner::parseCommandLineArguments()
     m_workbench = new QDesignerWorkbench(options.pluginPaths);
 
     emit initialized();
-    previousMessageHandler = qInstallMessageHandler(designerMessageHandler); // Warn when loading faulty forms
-    Q_ASSERT(previousMessageHandler);
 
     bool suppressNewFormShow = m_workbench->readInBackup();
 
diff --git a/src/designer/src/lib/shared/qdesigner_widget.cpp b/src/designer/src/lib/shared/qdesigner_widget.cpp
index 88f43d5ab..99fc6a50a 100644
--- a/src/designer/src/lib/shared/qdesigner_widget.cpp
+++ b/src/designer/src/lib/shared/qdesigner_widget.cpp
@@ -35,7 +35,11 @@ void QDesignerDialog::paintEvent(QPaintEvent *e)
     QPainter p(this);
     QStyleOption opt;
     opt.initFrom(this);
-    p.fillRect(e->rect(), palette().brush(backgroundRole()));
+    auto r = backgroundRole();
+    auto b = palette().brush(r);
+    qDebug() << __FUNCTION__ << r << b.color() << b.color().name();
+    p.fillRect(e->rect(), b);
+
     style()->drawPrimitive(QStyle::PE_Widget, &opt, &p, this);
     if (m_formWindow && m_formWindow->gridVisible())
         m_formWindow->designerGrid().paint(p, this, e);
@@ -59,7 +63,10 @@ void QDesignerWidget::paintEvent(QPaintEvent *e)
     QPainter p(this);
     QStyleOption opt;
     opt.initFrom(this);
-    p.fillRect(e->rect(), palette().brush(backgroundRole()));
+    auto r = backgroundRole();
+    auto b = palette().brush(r);
+    qDebug() << __FUNCTION__ << r << b.color() << b.color().name();
+    p.fillRect(e->rect(), b);
     style()->drawPrimitive(QStyle::PE_Widget, &opt, &p, this);
     if (m_formWindow && m_formWindow->gridVisible())
         m_formWindow->designerGrid().paint(p, this, e);
diff --git a/src/shared/qtpropertybrowser/qttreepropertybrowser.cpp b/src/shared/qtpropertybrowser/qttreepropertybrowser.cpp
index 00ba9b402..00099682e 100644
--- a/src/shared/qtpropertybrowser/qttreepropertybrowser.cpp
+++ b/src/shared/qtpropertybrowser/qttreepropertybrowser.cpp
@@ -912,8 +912,11 @@ void QtTreePropertyBrowser::setBackgroundColor(QtBrowserItem *item, const QColor
 {
     if (!d_ptr->m_indexToItem.contains(item))
         return;
-    if (color.isValid())
+    if (color.isValid()) {
+        qDebug() << __FUNCTION__ << item->property()->propertyName() << color
+                 << color.name();
         d_ptr->m_indexToBackgroundColor[item] = color;
+    }
     else
         d_ptr->m_indexToBackgroundColor.remove(item);
     d_ptr->m_treeWidget->viewport()->update();