diff --git a/sources/pyside6/libpyside/dynamicqmetaobject.cpp b/sources/pyside6/libpyside/dynamicqmetaobject.cpp
index 048001f81..dc4407abf 100644
--- a/sources/pyside6/libpyside/dynamicqmetaobject.cpp
+++ b/sources/pyside6/libpyside/dynamicqmetaobject.cpp
@@ -199,6 +199,7 @@ static bool checkMethodSignature(const QByteArray &signature)
 
 int MetaObjectBuilderPrivate::addSlot(const QByteArray &signature)
 {
+    qDebug() << "MOB:QByteArray" << __FUNCTION__ << signature;
     if (!checkMethodSignature(signature))
         return -1;
     m_dirty = true;
@@ -208,6 +209,7 @@ int MetaObjectBuilderPrivate::addSlot(const QByteArray &signature)
 
 int MetaObjectBuilder::addSlot(const char *signature)
 {
+    qDebug() << "MOB:char" << __FUNCTION__ << signature;
     return m_d->addSlot(signature);
 }
 
@@ -215,6 +217,7 @@ int MetaObjectBuilderPrivate::addSlot(const QByteArray &signature,
                                       const QByteArray &type,
                                       const QByteArray &tag)
 {
+    qDebug() << "MOB:3" << __FUNCTION__ << signature << type << tag;
     if (!checkMethodSignature(signature))
         return -1;
     m_dirty = true;
@@ -228,6 +231,7 @@ int MetaObjectBuilderPrivate::addSlot(const QByteArray &signature,
 
 int MetaObjectBuilder::addSlot(const char *signature, const char *type)
 {
+    qDebug() << "MOB:2 char" << __FUNCTION__ << signature << type;
     return m_d->addSlot(signature, type);
 }
 
diff --git a/sources/pyside6/libpyside/globalreceiverv2.cpp b/sources/pyside6/libpyside/globalreceiverv2.cpp
index 5fcf224ea..1c78fe5cd 100644
--- a/sources/pyside6/libpyside/globalreceiverv2.cpp
+++ b/sources/pyside6/libpyside/globalreceiverv2.cpp
@@ -152,6 +152,7 @@ int DynamicSlotDataV2::id(const char *signature) const
 int DynamicSlotDataV2::addSlot(const char *signature)
 {
     int index = id(signature);
+    qDebug() << "DynamicSlotDataV2::addSlot" << signature << index;
     if (index == -1)
         index = m_signatures[signature] = m_parent->metaObjectBuilder().addSlot(signature);
     return index;
diff --git a/sources/pyside6/libpyside/pysideslot.cpp b/sources/pyside6/libpyside/pysideslot.cpp
index fa7e89f42..aa0509532 100644
--- a/sources/pyside6/libpyside/pysideslot.cpp
+++ b/sources/pyside6/libpyside/pysideslot.cpp
@@ -4,11 +4,13 @@
 #include "pysidesignal_p.h"
 #include "pysideslot_p.h"
 #include "pysidestaticstrings.h"
+#include "pysideutils.h"
 
 #include <shiboken.h>
 
 #include <QtCore/QMetaObject>
 #include <QtCore/QString>
+#include <QtCore/QDebug>
 #include <signature.h>
 
 using namespace Shiboken;
@@ -90,6 +92,7 @@ int slotTpInit(PyObject *self, PyObject *args, PyObject *kw)
     for(Py_ssize_t i = 0, i_max = PyTuple_Size(args); i < i_max; i++) {
         PyObject *argType = PyTuple_GET_ITEM(args, i);
         const auto typeName = PySide::Signal::getTypeName(argType);
+        qDebug() << __FUNCTION__ <<i << argName << typeName << PySide::debugPyObject(argType);
         if (typeName.isEmpty()) {
             PyErr_Format(PyExc_TypeError, "Unknown signal argument type: %s", Py_TYPE(argType)->tp_name);
             return -1;
@@ -108,6 +111,9 @@ int slotTpInit(PyObject *self, PyObject *args, PyObject *kw)
     data->slotData->resultType = argResult
         ? PySide::Signal::getTypeName(argResult) : PySide::Signal::voidType();
 
+    qDebug() << __FUNCTION__ << "result=" << argName <<  data->slotData->resultType
+         << "args=" << data->slotData->args;
+
     return 0;
 }
 
@@ -132,6 +138,7 @@ PyObject *slotCall(PyObject *self, PyObject *args, PyObject * /* kw */)
         }
         const QByteArray returnType = QMetaObject::normalizedType(data->slotData->resultType);
         const QByteArray signature = data->slotData->name + '(' + data->slotData->args + ')';
+        qDebug() << __FUNCTION__ <<returnType <<  signature;
 
         PyObject *pySlotName = PySide::PySideMagicName::slot_list_attr();
         PySide::Slot::DataList *entryList = nullptr;
diff --git a/sources/pyside6/libpyside/qobjectconnect.cpp b/sources/pyside6/libpyside/qobjectconnect.cpp
index 3c5b75953..30317a7fb 100644
--- a/sources/pyside6/libpyside/qobjectconnect.cpp
+++ b/sources/pyside6/libpyside/qobjectconnect.cpp
@@ -205,6 +205,7 @@ QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *sign
     if (!signal || !PySide::Signal::checkQtSignal(signal))
         return {};
 
+    qDebug() << __FUNCTION__ << source << signal;
     const int signalIndex =
         PySide::SignalManager::registerMetaMethodGetIndex(source, signal + 1,
                                                           QMetaMethod::Signal);
@@ -268,6 +269,8 @@ QMetaObject::Connection qobjectConnectCallback(QObject *source, const char *sign
     if (!signal || !PySide::Signal::checkQtSignal(signal))
         return {};
 
+    qDebug() << __FUNCTION__ << source << signal << context;
+
     const int signalIndex =
         PySide::SignalManager::registerMetaMethodGetIndex(source, signal + 1,
                                                           QMetaMethod::Signal);
diff --git a/sources/pyside6/libpyside/signalmanager.cpp b/sources/pyside6/libpyside/signalmanager.cpp
index c38fc2764..56419a11f 100644
--- a/sources/pyside6/libpyside/signalmanager.cpp
+++ b/sources/pyside6/libpyside/signalmanager.cpp
@@ -670,8 +670,12 @@ int SignalManager::registerMetaMethodGetIndex(QObject *source, const char *signa
                  signature);
         return -1;
     }
+
     const QMetaObject *metaObject = source->metaObject();
     int methodIndex = metaObject->indexOfMethod(signature);
+    qDebug() << "SignalManager::registerMetaMethodGetIndex()" << source <<  signature
+             << type << "methodIndex=" << methodIndex;
+
     // Create the dynamic signal is needed
     if (methodIndex == -1) {
         SbkObject *self = Shiboken::BindingManager::instance().retrieveWrapper(source);
@@ -694,7 +698,7 @@ int SignalManager::registerMetaMethodGetIndex(QObject *source, const char *signa
         }
 
         if (type == QMetaMethod::Slot) {
-            qCWarning(lcPySide).noquote().nospace()
+            qWarning().noquote().nospace()
                 << "Warning: Registering dynamic slot \""
                 << signature << "\" on \"" << source->metaObject()->className()
                 << "\". Consider annotating with " << slotSignature(signature);