diff --git a/src/virtualkeyboard/InputPanel.qml b/src/virtualkeyboard/InputPanel.qml
index 676cee67..ab12d8dd 100644
--- a/src/virtualkeyboard/InputPanel.qml
+++ b/src/virtualkeyboard/InputPanel.qml
@@ -130,12 +130,17 @@ Item {
     /*! \internal */
     function keyboardRectangle() {
         var rect = Qt.rect(0, 0, keyboard.width, keyboard.height)
+        console.log('keyboardRectangle(): KB Size', keyboard.width, keyboard.height)
         const screenPosX = screenPos.x
         const screenPosY = screenPos.y
         if (desktopPanel) {
+            console.log('keyboardRectangle(): (desktopPanel) screenPos =', screenPosX, screenPosY)
             rect.x += screenPosX
             rect.y += screenPosY
+        } else {
+            console.log('keyboardRectangle(): No desktopPanel')
         }
+        console.log('keyboardRectangle() rets ', rect.width, 'x', rect.height, '+', rect.x, '+', rect.y)
         return mapToItem(null, rect)
     }
 }
diff --git a/src/virtualkeyboard/desktopinputpanel.cpp b/src/virtualkeyboard/desktopinputpanel.cpp
index 2c321dcd..0084b570 100644
--- a/src/virtualkeyboard/desktopinputpanel.cpp
+++ b/src/virtualkeyboard/desktopinputpanel.cpp
@@ -158,7 +158,9 @@ void DesktopInputPanel::repositionView(const QRect &rect)
         d->view->setResizeMode(QQuickView::SizeViewToRootObject);
         setInputRect(QRect());
         d->view->setGeometry(rect);
+        qDebug() << __FUNCTION__ << '1' << d->view->geometry() << rect;
         d->view->setResizeMode(QQuickView::SizeRootObjectToView);
+        qDebug() << __FUNCTION__ << '2' <<  d->view->geometry();
         if (inputContext)
             inputContext->setAnimating(false);
     }
@@ -166,6 +168,16 @@ void DesktopInputPanel::repositionView(const QRect &rect)
 
 void DesktopInputPanel::focusWindowChanged(QWindow *focusWindow)
 {
+    Q_D(DesktopInputPanel);
+    {
+        auto debug = qDebug();
+        debug << "DesktopInputPanel::focusWindowChanged" << focusWindow;
+        if (focusWindow)
+            debug << focusWindow->type();
+        if (d->view)
+            debug << "View: " << d->view->geometry();
+    }
+
     disconnect(this, SLOT(focusWindowVisibleChanged(bool)));
     disconnect(this, SLOT(screenChanged(QScreen*)));
     if (focusWindow) {
@@ -199,6 +211,7 @@ void DesktopInputPanel::screenChanged(QScreen *screen)
 
 void DesktopInputPanel::focusWindowVisibleChanged(bool visible)
 {
+    qDebug() << "DesktopInputPanel::focusWindowVisibleChanged" << visible;
     if (!visible) {
         QVirtualKeyboardInputContext *inputContext = qobject_cast<PlatformInputContext *>(parent())->inputContext();
         if (inputContext)
diff --git a/src/virtualkeyboard/inputview.cpp b/src/virtualkeyboard/inputview.cpp
index c2e29e0f..0f229360 100644
--- a/src/virtualkeyboard/inputview.cpp
+++ b/src/virtualkeyboard/inputview.cpp
@@ -19,6 +19,7 @@ InputView::InputView(QWindow *parent) :
 void InputView::resizeEvent(QResizeEvent *event)
 {
     QQuickWindow::resizeEvent(event);
+    qDebug() << "InputView::resizeEvent" <<event->size();
     emit sizeChanged();
 }
 
diff --git a/src/virtualkeyboard/platforminputcontext.cpp b/src/virtualkeyboard/platforminputcontext.cpp
index 0a98e7fc..3d0f0dc9 100644
--- a/src/virtualkeyboard/platforminputcontext.cpp
+++ b/src/virtualkeyboard/platforminputcontext.cpp
@@ -14,6 +14,7 @@
 
 #include <QWindow>
 #include <QGuiApplication>
+#include <QEvent>
 
 QT_BEGIN_NAMESPACE
 namespace QtVirtualKeyboard {
@@ -119,6 +120,7 @@ void PlatformInputContext::showInputPanel()
 
 void PlatformInputContext::hideInputPanel()
 {
+    qDebug() << __FUNCTION__;
     if (m_visible) {
         VIRTUALKEYBOARD_DEBUG() << "PlatformInputContext::hideInputPanel()";
         m_visible = false;
@@ -219,6 +221,7 @@ void PlatformInputContext::sendKeyEvent(QKeyEvent *event)
             focusWindow = app->focusWindow();
         }
     }
+    qDebug() << "PlatformInputContext::sendKeyEvent" << focusWindow << event;
     if (focusWindow) {
         m_filterEvent = event;
         QGuiApplication::sendEvent(focusWindow, event);
diff --git a/src/virtualkeyboard/qvirtualkeyboardinputcontext_p.cpp b/src/virtualkeyboard/qvirtualkeyboardinputcontext_p.cpp
index 2c555b95..c7c6ab29 100644
--- a/src/virtualkeyboard/qvirtualkeyboardinputcontext_p.cpp
+++ b/src/virtualkeyboard/qvirtualkeyboardinputcontext_p.cpp
@@ -20,6 +20,7 @@
 #include <QtGui/qpa/qplatformintegration.h>
 #include <QtGui/private/qguiapplication_p.h>
 #include <QQmlEngine>
+#include <QDebug>
 
 QT_BEGIN_NAMESPACE
 
@@ -102,6 +103,7 @@ void QVirtualKeyboardInputContextPrivate::setFocus(bool focus)
 
 QRectF QVirtualKeyboardInputContextPrivate::keyboardRectangle() const
 {
+    qDebug() << __FUNCTION__ << keyboardRect;
     return keyboardRect;
 }
 
@@ -110,6 +112,7 @@ void QVirtualKeyboardInputContextPrivate::setKeyboardRectangle(QRectF rectangle)
     if (keyboardRect != rectangle) {
         keyboardRect = rectangle;
         emit keyboardRectangleChanged();
+        qDebug() << __FUNCTION__ << rectangle;
         platformInputContext->emitKeyboardRectChanged();
     }
 }
@@ -287,6 +290,7 @@ KeyboardFunctionKey QVirtualKeyboardInputContextPrivate::keyboardFunctionKey(QtV
 void QVirtualKeyboardInputContextPrivate::onInputItemChanged()
 {
     QObject *item = inputItem();
+    qDebug() << "QVirtualKeyboardInputContextPrivate::onInputItemChanged" << item;
     if (item) {
         if (QQuickItem *vkbPanel = qobject_cast<QQuickItem*>(inputPanel)) {
             if (QQuickItem *quickItem = qobject_cast<QQuickItem*>(item)) {